stages:
  - "🗜 lint"
  - test
  
image: node:latest

cache:
  paths:
    - node_modules/

eslint:
  stage: "🗜 lint"
  before_script:
    - npm install
  script:
    - npx eslint *js routers/*js lib/*js
  allow_failure: true
  artifacts:
    paths:
      - eslint-junit.xml
    reports:
      junit:
        - eslint-junit.xml
  needs: []
  except:
    refs:
      - schedules

audit:
  stage: "🗜 lint"
  before_script:
    - npm install --production
  script:
    - npm ls --production
    - npm audit --production || npm audit fix --production
  rules:
    - if: '$CI_PIPELINE_SOURCE != "schedule"'
      allow_failure: true
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
  needs: []
  artifacts:
    paths:
      - package.json
      - package-lock.json

.test_env:
  stage: test
  services:
    - mongo:latest
    - ${CI_REGISTRY}/${CI_PROJECT_NAMESPACE}/container:latest

test:
  extends: .test_env
  script:
    - npm install
    - npm test
